| ARX 1.0 The next-generation open source augmented reality toolkit.

Loading...
Searching...
No Matches
Public Attributes | List of all members
ARMarkerInfo Struct Reference

Describes a detected trapezoidal area (a candidate for a marker match). More...

`#include <ar.h>`

Collaboration diagram for ARMarkerInfo:
[legend]

## Public Attributes
int | area
| Area in pixels of the largest connected region, comprising the marker border and regions connected to it. Note that this is not the same as the actual onscreen area inside the marker border.
int | id
| If pattern detection mode is either pattern mode OR matrix but not both, will be marker ID (>= 0) if marker is valid, or -1 if invalid.
int | idPatt
| If pattern detection mode includes a pattern mode, will be marker ID (>= 0) if marker is valid, or -1 if invalid.
int | idMatrix
| If pattern detection mode includes a matrix mode, will be marker ID (>= 0) if marker is valid, or -1 if invalid.
int | dir
| If pattern detection mode is either pattern mode OR matrix but not both, and id != -1, will be marker direction (range 0 to 3, inclusive).
int | dirPatt
| If pattern detection mode includes a pattern mode, and id != -1, will be marker direction (range 0 to 3, inclusive).
int | dirMatrix
| If pattern detection mode includes a matrix mode, and id != -1, will be marker direction (range 0 to 3, inclusive).
ARdouble | cf
| If pattern detection mode is either pattern mode OR matrix but not both, will be marker matching confidence (range 0.0 to 1.0 inclusive) if marker is valid, or -1.0 if marker is invalid.
ARdouble | cfPatt
| If pattern detection mode includes a pattern mode, will be marker matching confidence (range 0.0 to 1.0 inclusive) if marker is valid, or -1.0 if marker is invalid.
ARdouble | cfMatrix
| If pattern detection mode includes a matrix mode, will be marker matching confidence (range 0.0 to 1.0 inclusive) if marker is valid, or -1.0 if marker is invalid.
ARdouble | pos [2]
| 2D position (in camera image coordinates, origin at top-left) of the centre of the marker.
ARdouble | line [4][3]
| Line equations for the 4 sides of the marker.
ARdouble | vertex [4][2]
| 2D positions (in camera image coordinates, origin at top-left) of the corners of the marker. vertex[(4 - dir)%4][] is the top-left corner of the marker. Other vertices proceed clockwise from this. These are idealised coordinates (i.e. the onscreen position aligns correctly with the undistorted camera image.)
ARMarkerInfo2 * | markerInfo2Ptr
| Pointer to source region info for this marker.
AR_MARKER_INFO_CUTOFF_PHASE | cutoffPhase
| If a trapezoidal region is detected, but is eliminated from the candidates for tracking, this field is filled out with the tracking phase at which the marker was cut off. An English-language description of the phase can be obtained by indexing into the C-string array arMarkerInfoCutoffPhaseDescriptions[].
int | errorCorrected
| For marker types including error detection and correction, the numbers of errors detected and corrected.
uint64_t | globalID
| If arPattDetectionMode is a matrix mode, matrixCodeType is AR_MATRIX_CODE_GLOBAL_ID, and idMatrix >= 0, will contain the globalID.
int | matched
| Initialised to 0 during marker detection, a non-zero value indicates that this marker has already been matched against a search set of markers, and should be ignored as a candidate for further matches.

## Detailed Description

Describes a detected trapezoidal area (a candidate for a marker match).

After marker detection, a number of trapezoidal areas in the camera image will have been identified. An ARMarkerInfo struct is returned for each area so matched. Trapezoidal areas which have been matched with marker images (in pattern mode) or barcodes (in matrix mode) will have valid values assigned to the appropriate id field.

## Member Data Documentation

## ◆ area

int ARMarkerInfo::area

Area in pixels of the largest connected region, comprising the marker border and regions connected to it. Note that this is not the same as the actual onscreen area inside the marker border.

## ◆ cf

ARdouble ARMarkerInfo::cf

If pattern detection mode is either pattern mode OR matrix but not both, will be marker matching confidence (range 0.0 to 1.0 inclusive) if marker is valid, or -1.0 if marker is invalid.

## ◆ cfMatrix

ARdouble ARMarkerInfo::cfMatrix

If pattern detection mode includes a matrix mode, will be marker matching confidence (range 0.0 to 1.0 inclusive) if marker is valid, or -1.0 if marker is invalid.

## ◆ cfPatt

ARdouble ARMarkerInfo::cfPatt

If pattern detection mode includes a pattern mode, will be marker matching confidence (range 0.0 to 1.0 inclusive) if marker is valid, or -1.0 if marker is invalid.

## ◆ cutoffPhase

AR_MARKER_INFO_CUTOFF_PHASE ARMarkerInfo::cutoffPhase

If a trapezoidal region is detected, but is eliminated from the candidates for tracking, this field is filled out with the tracking phase at which the marker was cut off. An English-language description of the phase can be obtained by indexing into the C-string array arMarkerInfoCutoffPhaseDescriptions[].

## ◆ dir

int ARMarkerInfo::dir

If pattern detection mode is either pattern mode OR matrix but not both, and id != -1, will be marker direction (range 0 to 3, inclusive).

## ◆ dirMatrix

int ARMarkerInfo::dirMatrix

If pattern detection mode includes a matrix mode, and id != -1, will be marker direction (range 0 to 3, inclusive).

## ◆ dirPatt

int ARMarkerInfo::dirPatt

If pattern detection mode includes a pattern mode, and id != -1, will be marker direction (range 0 to 3, inclusive).

## ◆ errorCorrected

int ARMarkerInfo::errorCorrected

For marker types including error detection and correction, the numbers of errors detected and corrected.

## ◆ globalID

uint64_t ARMarkerInfo::globalID

If arPattDetectionMode is a matrix mode, matrixCodeType is AR_MATRIX_CODE_GLOBAL_ID, and idMatrix >= 0, will contain the globalID.

## ◆ id

int ARMarkerInfo::id

If pattern detection mode is either pattern mode OR matrix but not both, will be marker ID (>= 0) if marker is valid, or -1 if invalid.

## ◆ idMatrix

int ARMarkerInfo::idMatrix

If pattern detection mode includes a matrix mode, will be marker ID (>= 0) if marker is valid, or -1 if invalid.

## ◆ idPatt

int ARMarkerInfo::idPatt

If pattern detection mode includes a pattern mode, will be marker ID (>= 0) if marker is valid, or -1 if invalid.

## ◆ line

ARdouble ARMarkerInfo::line[4][3]

Line equations for the 4 sides of the marker.

## ◆ markerInfo2Ptr

ARMarkerInfo2* ARMarkerInfo::markerInfo2Ptr

Pointer to source region info for this marker.

## ◆ matched

int ARMarkerInfo::matched

Initialised to 0 during marker detection, a non-zero value indicates that this marker has already been matched against a search set of markers, and should be ignored as a candidate for further matches.

## ◆ pos

ARdouble ARMarkerInfo::pos[2]

2D position (in camera image coordinates, origin at top-left) of the centre of the marker.

## ◆ vertex

ARdouble ARMarkerInfo::vertex[4][2]

2D positions (in camera image coordinates, origin at top-left) of the corners of the marker. vertex[(4 - dir)%4][] is the top-left corner of the marker. Other vertices proceed clockwise from this. These are idealised coordinates (i.e. the onscreen position aligns correctly with the undistorted camera image.)

The documentation for this struct was generated from the following file:

- Source/ARX/AR/include/ARX/AR/ar.h